package com.microservices.zone.partners.mapper;

import com.microservices.zone.partners.domain.ZonePartners;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 特色专区合作伙伴Mapper接口
 * 
 * @author otto
 * @date 2023-06-07
 */
@Mapper
public interface ZonePartnersMapper
{
    /**
     * 查询特色专区合作伙伴
     * 
     * @param id 特色专区合作伙伴主键
     * @return 特色专区合作伙伴
     */
    public ZonePartners selectZonePartnersById(Long id);

    /**
     * 查询特色专区合作伙伴列表
     * 
     * @param zonePartners 特色专区合作伙伴
     * @return 特色专区合作伙伴集合
     */
    public List<ZonePartners> selectZonePartnersList(ZonePartners zonePartners);

    /**
     * 新增特色专区合作伙伴
     * 
     * @param zonePartners 特色专区合作伙伴
     * @return 结果
     */
    public int insertZonePartners(ZonePartners zonePartners);

    /**
     * 修改特色专区合作伙伴
     * 
     * @param zonePartners 特色专区合作伙伴
     * @return 结果
     */
    public int updateZonePartners(ZonePartners zonePartners);

    /**
     * 删除特色专区合作伙伴
     * 
     * @param id 特色专区合作伙伴主键
     * @return 结果
     */
    public int deleteZonePartnersById(Long id);

    /**
     * 批量删除特色专区合作伙伴
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteZonePartnersByIds(Long[] ids);

    /**
     * 获取合作伙伴总数
     *
     * @param zonePartners
     * @return
     */
    Integer selectZonePartnersCount(ZonePartners zonePartners);

    /**
     * 查询专区下最大序号
     *
     * @param zoneId
     * @return
     */
    Integer selectMaxSortByZoneId(ZonePartners zonePartners);

    /**
     * 查询合作伙伴在专区下总数量
     *
     * @param zoneId
     * @return
     */
    Integer selectCountByZoneId(ZonePartners zonePartners);

    /**
     * 获取指定序号的合作伙伴
     *
     * @param zonePartners
     * @param order
     * @param b
     * @return
     */
    ZonePartners selectZonePartnersByOrderAndZoneId(@Param("zonePartners") ZonePartners zonePartners, @Param("order") Integer order, @Param("isContainsSelf") boolean isContainsSelf);

    /**
     * 查询专区下最小排序值
     *
     * @param zoneId
     * @return
     */
    int selectMinSortByZoneId(ZonePartners zonePartners);

    /**
     * 批量增加大于指定排序的排序值
     *
     * @param zoneId
     * @param setSort
     * @return
     */
    Integer batchUpdateSortIncreased(@Param("zonePartners") ZonePartners zonePartners, @Param("setSort") Integer setSort);

    /**
     * 通过专区id删除合作伙伴
     *
     * @param zoneId 专区id
     */
    void deleteZonePartnersByZoneId(Long zoneId);
}
